#!/usr/bin/bash

DRIVER=$1
LOG_FILE=$2

exec 2>&1
exec >>$LOG_FILE

RUN_SCRIPT=`mktemp /tmp/drv_installXXXXX.sh`
chmod 755 $RUN_SCRIPT

if echo $DRIVER | grep '^kmod-focal-spi'; then
	cat >$RUN_SCRIPT <<EOF
#!/bin/bash
cat > /etc/yum.repos.d/inferit.repo << FOE
[inferit]
name=MSVSphere 9 - Inferit Hardware
baseurl=https://repo1.msvsphere-os.ru/vault/inferit/9/x86_64/
enabled=1
gpgcheck=1
countme=1
gpgkey=file:///etc/pki/rpm-gpg/RPM-GPG-KEY-MSVSphere-9
metadata_expire=86400
enabled_metadata=1
FOE

dnf -y install $DRIVER libfprint-focal-spi --refresh
EOF
elif echo $DRIVER | grep '^akmod-focal-spi'; then
	cat >$RUN_SCRIPT <<EOF
#!/bin/bash
cat > /etc/yum.repos.d/inferit.repo << FOE
[inferit]
name=MSVSphere 9 - Inferit Hardware
baseurl=https://repo1.msvsphere-os.ru/vault/inferit/9/x86_64/
enabled=1
gpgcheck=1
countme=1
gpgkey=file:///etc/pki/rpm-gpg/RPM-GPG-KEY-MSVSphere-9
metadata_expire=86400
enabled_metadata=1
FOE

dnf -y install $DRIVER libfprint-focal-spi --refresh || exit 1
systemctl enable --now akmods || exit 1
# always run akmods and dracut at the end of updates
akmods || exit 1
dracut -f --regenerate-all
EOF
elif echo $DRIVER | grep '^kmod-'; then
		cat >$RUN_SCRIPT <<EOF
#!/bin/bash
dnf -y install $DRIVER --refresh
EOF
elif echo $DRIVER | grep '^akmod-'; then
	cat >$RUN_SCRIPT <<EOF
#!/bin/bash
dnf -y install $DRIVER --refresh || exit 1
systemctl enable --now akmods || exit 1
# always run akmods and dracut at the end of updates
akmods || exit 1
dracut -f --regenerate-all 
EOF
elif echo $DRIVER | grep '^alsa-firmware'; then
cat >$RUN_SCRIPT <<EOF
#!/bin/bash

dnf -y install $DRIVER
exit 0
EOF
else
    echo "Error"
    exit 1
fi

pkexec $RUN_SCRIPT
